//================================================================================
//  
//        SDR-1.c           ȈSDR(Software Defined Radio)C
//  
//        (c)2010/10/31  by OjisanKoubou
//  
//================================================================================
//  
//  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
//  ľړIɂ́ACAȂǎRɎgpł܂B
//  \ۂ͒쌠\Ȃ悤ɂĂB
//  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃ
//  ƓIp͂߂B
//

//ATMEGA328
//  Fuse L  : 11100111   CKȂASUXtalU
//  Fuse H  : 11011001   l
//  Fuse EXT: 111        l
//


#include "SDR-1.h"


//
//  O[oϐ
//
volatile uint8 dabuf[8] = { 0xE8, 0xE4, 0xE2, 0xF0, 0xE8, 0xE4, 0xE2, 0xF0 }; // RL, RH, LL, LH, [4]ȍ~͎ɏo͂f[^
volatile uint8 adbuf[8];

volatile uint8* pad = adbuf;
volatile uint8* pda = dabuf;
volatile uint8 intcnt = 4;              // M荞݃JE^[
volatile uint8 sync = 1;                // 荞݃[`ŃNÂ C vO͂gē
volatile uint8 sync_error = 0;          // [vŎԂ肷ēƂȂ

int16  fll_freq_khz  = 0;               // FLL ŎۂɔUg kHz
int16  fll_freq_hz   = 0;               // FLL ŎۂɔUg 1000/256 Hz P
int8   is_fll_locked = 0;               // gbNH

uint8  mode        = 0;                 // 0: normal  1:step  2:memory write  3:notch  4:page  5:memory erase
uint8  memorymode  = 0;                 // 0: Freq mode   1: Memory mode
uint16 freq_khz    = 531;               // Mg kHz
uint8  freq_hz     = 0;                 // Mg 1000/256 = 3.9HzXebv
int8   mempage     = 0;                 // 0..7
int8   stapos      = 0;                 // 0..7
int8   lcd_contrast= 3;                 // LCD RgXg 0..7
int8   volume      = 10;                // {[ 0..+49dB
int8   fstep_khz   = 9;                 // gXebv  1k  5k  9k  10k
int8   fadj        = -2;                 // g -99..+99 * 1/65536  15.25ppm/step
uint8  fs          = 24;                // 12, 24 kHz
int8   offset      = -6;                // AM ŕϊgǂɂ邩
uint8  ssb_mode    = 0;                 // 0:LSB   1:USB   2:I/Q(hilbert)
uint8  notch       = 0xFF;              // 0:Notch      OFF   0xFF:Notch      ON
uint8  deemphasis  = 0xFF;              // 0:Deemphasis OFF   0xFF:Deemphasis ON
uint8  agc         = 0xFF;              // 0:AGC        OFF   0xFF:AGC        ON

char lcdc_buf[65] = "                                                                ";


//
//  ق̃\[Xt@Cǂݍ
//
#include "lcdc16xn.c"
#include "hex2str.c"
#include "dec2str.c"
#include "demod.c"
#include "uda1345.c"
#include "eeprom.c"
#include "user_interface.c"
#include "dispatch.c"
#include "sine.c"


//
//  [U[vO
//
void userprogram_init( void ) {
  hardware_init();
  adda_start();
  uda1345_init();
  read_setting();
  
  LED3_ON;
  dly_usec(50000);
  dly_usec(50000);
  dly_usec(50000);
  dly_usec(50000);
  LED3_OFF;
  
  disp();
}


//
//  n[hEFA
//
void hardware_init( void ) {
  // h^n|[g̐ݒ
                    // |[go
  PORTB = 0x00;         // PB 7:XTAL 6:XTAL 5:LCD_E 4:LCD_RS 3:LED3 2:PD_POLARITY 1:PD 0:
  PORTC = 0x00;         // PC 6:RESET 5: 4:PD_MON 3..0:LCD_DATA7..4
  PORTD = 0x00;         // PD 7:LCD_E 6:SCK 5:OSC_IN 4:BCK 3:LRCK 2:LED2 1:DIN 0:DOUT
  
                    // |[go͕
  DDRB  = 0x3F;         // PB 7:XTAL 6:XTAL 5:L3CLK 4:L3MODE 3:L3DATA 2:PD 1:LED2 0:LED1
  DDRC  = 0x3F;         // PC 6:RESET 5:LCD_RS 4:LCD_E 3..0:LCD_DATA7..4
  DDRD  = 0xDD;         // PD 7:LCD_V 6:SCK 5:OSC_IN 4:BCK 3:LRCK 2:LED3 1:DIN 0:DOUT
  
  TCCR1B = 0x07;    // T1 ̗オ
  
  lcdc_init();      // lcd ̏̓|[gݒɍs
  lcdc_putstr_pgm( "SDR-1 2010/10/31OjisanKoubou    " );
  lcdc_setcg_pgm( 0, "\020\030\027\023\023\027\030\020" );  // speaker mark
  lcdc_setcg_pgm( 1, "\000\003\001\001\011\037\010\000" );  // return mark
  lcdc_setcg_pgm( 2, "\000\021\031\025\023\021\000\000" );  // Notch OFF
  lcdc_setcg_pgm( 3, "\000\021\031\025\023\021\000\037" );  // Notch ON
  lcdc_setcg_pgm( 4, "\000\036\021\021\021\036\000\000" );  // Deemphasis OFF
  lcdc_setcg_pgm( 5, "\000\036\021\021\021\036\000\037" );  // Deemphasis ON
  lcdc_setcg_pgm( 6, "\000\004\012\021\037\021\000\000" );  // AGC OFF
  lcdc_setcg_pgm( 7, "\000\004\012\021\037\021\000\037" );  // AGC ON
}


//
//  AD/DA Jn
//
void adda_start( void ) {
  LED2_ON; // **** DEBUG **** DEBUG **** DEBUG **** DEBUG **** DEBUG **** DEBUG **** DEBUG
  
  UCSR0C = (1<<UMSEL01) | (1<<UMSEL00) | (1<<UCPHA0) | (1<<UCPOL0);  // MasterSPImode, mode3
  UCSR0B = (0<<RXCIE0) | (0<<RXEN0) | (1<<TXEN0);  // M荞ݕsAMs
  while( !(UCSR0A & (1<<UDRE0)) );  // M܂ő҂
  dly_usec( 30 );                   // ׂđMI܂ő҂
  uint8 tmp = UDR0; tmp = UDR0;     // Mf[^̂Ă
  loc_cpu();
  
  if( fs == 24 ) {
    TCCR0B = 0x01;  // Ou = 1
    OCR0A  = 0x01;  // SCK=24576k/2/1/(1+1)=6144kHz
    TCCR0A = 0x42;  // rvŃgOó@OC0A:SCK = 6144kHz( 256fs )
    
    TCCR2B = 0x0A;  // PWM@1/8
    TCCR2A = 0x33;  // rvŔ]@PWM@OC2B:LRCK
    OCR2A  = 0x7F;  // =127  LRCK=24576k/8/(127+1)=24kHz
    OCR2B  = 0x3F;  // =63  
    
    UCSR0B = (1<<RXCIE0) | (1<<RXEN0) | (1<<TXEN0);  // M荞݁AM
    UBRR0  = 15;    // BCK = fclk/(2*(15+1)) = 768kHz
    UDR0   = 0;     // dummy RH o
    
    while(  (PIND&(1<<4)) );  // BCK==H ?
    TCNT2  = 0;     // LRCK  SPI Ɠ
    
  }else
  if( fs == 12 ) {
    TCCR0B = 0x01;  // Ou = 1
    OCR0A  = 0x03;  // SCK=24576k/2/1/(3+1)=3072kHz
    TCCR0A = 0x42;  // rvŃgOó@OC0A:SCK = 3072kHz( 256fs )
    
    TCCR2B = 0x0A;  // PWM@1/8
    TCCR2A = 0x33;  // rvŔ]@PWM@OC2B:LRCK
    OCR2A  = 0xFF;  // =255  LRCK=24576k/8/(255+1)=12kHz
    OCR2B  = 0x7F;  // =127
    
    while(  (PIND&(1<<3)) );
    
    UCSR0B = (1<<RXCIE0) | (1<<RXEN0) | (1<<TXEN0);  // M荞݁AM
    UBRR0  = 31;    // BCK = fclk/(2*(31+1)) = 384kHz
    UDR0   = 0;     // dummy RH o
    
    while(  (PIND&(1<<4)) );  // BCK==H ?
    TCNT2  = 0;     // LRCK  SPI Ɠ
    
  }
  
  LED2_OFF; // **** DEBUG **** DEBUG **** DEBUG **** DEBUG **** DEBUG **** DEBUG **** DEBUG
  
  intcnt  = 4;
  pad  = adbuf;
  pda  = dabuf;
  unl_cpu();    // 荞݂
  UDR0 = 0;     // dummy RL o
}


//
//      CvO
//
int main( void ) {
  userprogram_init();
  
  while(1) {                            // C[v
    
    adda_start();                       // fs ύX
    while( fs == 24 ) {                 // fs=24kHz ̂Ƃ̃[v
      LED2_OFF;                         // ******
      if( sync == 0 ) {
        sync_error = 1;
        
        LED2_ON;                        // ****** sœ_
        
      }
      while( sync );                    // f[^M҂
      sync = 1;
      dispatch_24k();                   // 낢ȏs
      am_demod();
    }
    
    adda_start();                       // fs ύX
    while( fs == 12 ) {                 // fs=12kHz ̂Ƃ̃[v
      
      LED2_OFF;                         // ******
      
      if( sync == 0 ) {
        sync_error = 1;
        
        LED2_ON;                        // ****** sœ_
        
      }
      while( sync );                    // f[^M҂
      sync = 1;
      dispatch_12k();                   // 낢ȏs
      ssb_demod();
    }
    
  }
  
} 


//
//      gݒ
//
void set_freq( void ) {
  fll_freq_khz = (freq_khz+offset)*4;   // FLL 4{̎gŔU
  
  int16 fadj_h = fll_freq_khz>>8;       // g
  int16 fadj_l = fll_freq_khz&0x00FF;   // g
  fadj_h *= fadj;
  fadj_l *= fadj;
  int16 fadj_256 = fadj_h + fadj_l/256;
  
  fll_freq_hz = freq_hz + (fadj_256 & 0x00FF);
  if( fll_freq_hz & 0xFF00 ) {
    fll_freq_hz = fll_freq_hz & 0x00FF;
    fll_freq_khz++;
  }
  if( fadj_256 < 0 ) fadj_256 -= 256;
  fadj_256 = fadj_256/256;
  fll_freq_khz += fadj_256;
}


//
//      [ǎgݒ    
//
void set_station( int8 d ) {
  int8 stapos_prev = stapos;
  while(1) {
    stapos += d;                        //  +1 or -1 
    if( stapos < 0 ) stapos = STA_N-1;
    if( stapos == STA_N ) stapos = 0;
    if( read_freq() ) break;            // [Ɏgf[^
    if( stapos == stapos_prev ) break;  // ꏄI
  }
}


