//================================================================================
//  
//        eeprom.c           ddoqnl݁Eǂݏo
//  
//        (c)2010/10/31  by OjisanKoubou
//  
//================================================================================
//  
//  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
//  ľړIɂ́ACAȂǎRɎgpł܂B
//  \ۂ͒쌠\Ȃ悤ɂĂB
//  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃ
//  ƓIp͂߂B
//



//
//      X^eBbNϐ
//
static uint16 eep_setting_adr = 0x0010;        // EEPROM ݒAhX


//
//      EEPROM ݒǂ
//
void read_setting( void ) {
  uint8 isvalid;
  eep_setting_adr = 0x0010;
  while(1) {
    isvalid = eeprom_read_byte( (const uint8_t *)eep_setting_adr );
    if( isvalid == 0x55 ) {             // Lȃf[^H
      eeprom_busy_wait();
      mode        = eeprom_read_byte( (const uint8_t *)(eep_setting_adr+1 )); eeprom_busy_wait();
      memorymode  = eeprom_read_byte( (const uint8_t *)(eep_setting_adr+2 )); eeprom_busy_wait();
      freq_khz    = eeprom_read_word( (const uint16_t *)(eep_setting_adr+3)); eeprom_busy_wait();
      freq_hz     = eeprom_read_byte( (const uint8_t *)(eep_setting_adr+5 )); eeprom_busy_wait();
      mempage     = eeprom_read_byte( (const uint8_t *)(eep_setting_adr+6 )); eeprom_busy_wait();
      stapos      = eeprom_read_byte( (const uint8_t *)(eep_setting_adr+7 )); eeprom_busy_wait();
      lcd_contrast= eeprom_read_byte( (const uint8_t *)(eep_setting_adr+8 )); eeprom_busy_wait();
      volume      = eeprom_read_byte( (const uint8_t *)(eep_setting_adr+9 )); eeprom_busy_wait();
      fstep_khz   = eeprom_read_byte( (const uint8_t *)(eep_setting_adr+10)); eeprom_busy_wait();
      fadj        = eeprom_read_byte( (const uint8_t *)(eep_setting_adr+11)); eeprom_busy_wait();
      
      uint8 tmp  = eeprom_read_byte( (const uint8_t *)(eep_setting_adr+12)); eeprom_busy_wait();
      ssb_mode   = (tmp&0x20)? 1:0;
      fs         = (tmp&0x10)? 24:12;
      offset     = (tmp&0x08)? 6:-6;
      if( fs == 12 ) offset = 0;
      agc        = (tmp&0x04)? 0xFF:0;
      deemphasis = (tmp&0x02)? 0xFF:0;
      notch      = (tmp&0x01)? 0xFF:0;
      
      break;
    }
    eep_setting_adr += 0x0010;
    if( eep_setting_adr >= 0x0100 ) {
      eep_setting_adr = 0x0010;
      break;
    }
  }
  
  set_freq();
  uda1345_deemphasis(deemphasis);
  
}


//
//      EEPROM ɐݒ
//
void write_setting( void ) {
  eeprom_write_byte( (uint8_t *)eep_setting_adr, 0xFF );           // Õf[^𖳌ɂ
  eeprom_busy_wait();
  eep_setting_adr += 0x0010;
  if( eep_setting_adr >= 0x0100 ) eep_setting_adr = 0x0010;
  
  eeprom_write_byte( (uint8_t *)(eep_setting_adr   ), 0x55        ); eeprom_busy_wait(); // Lf[^}[N
  eeprom_write_byte( (uint8_t *)(eep_setting_adr+1 ), mode        ); eeprom_busy_wait(); // 
  eeprom_write_byte( (uint8_t *)(eep_setting_adr+2 ), memorymode  ); eeprom_busy_wait(); // 
  eeprom_write_word( (uint16_t *)(eep_setting_adr+3), freq_khz    ); eeprom_busy_wait(); // 
  eeprom_write_byte( (uint8_t *)(eep_setting_adr+5 ), freq_hz     ); eeprom_busy_wait(); // 
  eeprom_write_byte( (uint8_t *)(eep_setting_adr+6 ), mempage     ); eeprom_busy_wait(); // 
  eeprom_write_byte( (uint8_t *)(eep_setting_adr+7 ), stapos      ); eeprom_busy_wait(); // 
  eeprom_write_byte( (uint8_t *)(eep_setting_adr+8 ), lcd_contrast); eeprom_busy_wait(); // 
  eeprom_write_byte( (uint8_t *)(eep_setting_adr+9 ), volume      ); eeprom_busy_wait(); // 
  eeprom_write_byte( (uint8_t *)(eep_setting_adr+10), fstep_khz   ); eeprom_busy_wait(); // 
  eeprom_write_byte( (uint8_t *)(eep_setting_adr+11), fadj        ); eeprom_busy_wait(); // 
  
  uint8 tmp = ((ssb_mode==1)?0x20:0) | ((fs==24)?0x10:0) | ((offset==6)?0x08:0) | ((agc)?0x04:0) | ((deemphasis)?0x02:0) | ((notch)?0x01:0);
  eeprom_write_byte( (uint8_t *)(eep_setting_adr+12), tmp );
  
}


//
//      EEPROM Ɏgf[^
//
void write_freq( void ) {
  uint16 eep_freq_adr = 0x0100 + mempage*64;    // EEPROM gf[^AhX
  uint16 f;
  
  for( uint8 i=0; i<STA_N; i++ ) {      // 󂢂ĂꏊT
    eeprom_busy_wait();
    f = eeprom_read_word( (const uint16_t *)eep_freq_adr );
    if( f == 0xFFFF ) {                 // 
      eeprom_busy_wait();
      eeprom_write_word( (uint16_t *)eep_freq_adr, freq_khz );  eeprom_busy_wait();
      eeprom_write_byte( (uint8_t *)(eep_freq_adr+2), freq_hz );eeprom_busy_wait();
      uint8 tmp = ((ssb_mode==1)?0x20:0) | ((fs==24)?0x10:0) | ((offset==6)?0x08:0) | ((agc)?0x04:0) | ((deemphasis)?0x02:0) | ((notch)?0x01:0);
      eeprom_write_byte( (uint8_t *)(eep_freq_adr+3), tmp );
      return;
    }
    eep_freq_adr += 4;
  }
}


//
//      EEPROM  stapos ̎gf[^ǂ
//
int8 read_freq( void ) {
    eeprom_busy_wait();
    uint16 f = eeprom_read_word( (const uint16_t *)(0x0100 + mempage*64+stapos*4) );
    if( f == 0xFFFF ) return 0;
    freq_khz = f;
    eeprom_busy_wait();
    freq_hz = eeprom_read_byte( (const uint8_t *)(0x0100 + mempage*64+stapos*4 + 2) ); eeprom_busy_wait();
    uint8 tmp = eeprom_read_byte( (const uint8_t *)(0x0100 + mempage*64+stapos*4 + 3) );
    ssb_mode   = (tmp&0x20)? 1:0;
    fs         = (tmp&0x10)? 24:12;
    offset     = (tmp&0x08)? 6:-6;
    if( fs == 12 ) offset = 0;
    agc        = (tmp&0x04)? 0xFF:0;
    deemphasis = (tmp&0x02)? 0xFF:0;
    notch      = (tmp&0x01)? 0xFF:0;
    
    uda1345_deemphasis(deemphasis);
    set_freq();
    adda_start();                         // fs ύX
    return 1;
}


//
//      EEPROM ̎gf[^
//
void erase_freq( void ) {
  uint16 eep_freq_adr = 0x0100 + mempage*64 + stapos*4;   // EEPROM gf[^AhX
  eeprom_busy_wait();
  eeprom_write_word( (uint16_t *)(eep_freq_adr), 0xFFFF ); // 
}



