//================================================================================
//  
//        lcdc16xn.c           LN^[kbcPU@QASs
//  
//        (c)2010/10/31  by OjisanKoubou
//  
//================================================================================
//  
//  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
//  ľړIɂ́ACAȂǎRɎgpł܂B
//  \ۂ͒쌠\Ȃ悤ɂĂB
//  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃ
//  ƓIp͂߂B
//



//
//      ֐vg^Cv
//
static void lcdc_write8( uint8 data );
static void lcdc_write4( uint8 data );


//
//      X^eBbNϐ
//
static uint8 lcdx, lcdy;


//
//      `
//
#define  LCDC_E_HIGH()   sbi( LCDC_CTRL, LCDC_E )
#define  LCDC_E_LOW()    cbi( LCDC_CTRL, LCDC_E )
#define  LCDC_RS_HIGH()  sbi( LCDC_CTRL, LCDC_RS )
#define  LCDC_RS_LOW()   cbi( LCDC_CTRL, LCDC_RS )


//
// kbc
//
void lcdc_init( void ) {
  dly_usec( 30000 );            // d 15ms ȏ҂
  LCDC_RS_LOW();                // LCD RS = 0  R}h
  lcdc_write4( 0x33 );
  dly_usec( 10000 );             // 4.1ms ȏ҂
  lcdc_write4( 0x33 );
  dly_usec( 10000 );
  lcdc_write4( 0x33 );
  dly_usec( 10000 );
  lcdc_write4( 0x22 );          // Srbg[h
  dly_usec( 10000 );

  lcdc_write8( 0x28 );          // SrbgAQs\ATVhbg
  lcdc_write8( 0x0C );          // \ ON
  lcdc_write8( 0x06 );          // increment, no shift
  lcdc_write8( LCDC_NOCURSOR ); // J\[Ȃ
  lcdc_cls();                   // fBXv[NA
}


//
// kbc̉ʃNA
//
void lcdc_cls( void ) {
  lcdc_write8( 0x01 );        // fBXv[NA 
  dly_usec( 2500 );           // ő 1.52ms   VFD ł2.3ms
  lcdx = lcdy = 0;
}


//
// J[\ x,y Ɉړ
//
void lcdc_xy( uint8 x, uint8 y ) {
  uint8 adr;
  lcdx = x;
  if( lcdx>=LCDC_MAX_X ) { lcdx=0; y++; }
  lcdy = y;
  if( lcdy>=LCDC_MAX_Y ) lcdy=0;
  adr = 0x80;
  if( LCDC_MAX_Y==2 ) {
    if( lcdy==1 ) adr = 0xC0;
  }else if( LCDC_MAX_Y==4 ){
    if     ( lcdy==1 ) adr = 0xC0;
    else if( lcdy==2 ) adr = 0x90;
    else if( lcdy==3 ) adr = 0xD0;
  }
  adr += lcdx;
  lcdc_write8( adr );         // Set DDRAM address 
}


//
// [U[`    ch:0-7   cgdata:8oCg
//
void _lcdc_setcg_pgm( char ch, const prog_char *str ) {
  uint8 i;
  lcdc_write8( 0x40+(ch<<3) );   // CGRAM address set
  LCDC_RS_HIGH();           // LCD RS = 1  f[^
  for( i=0; i<8; i++ ) {
    lcdc_write8( pgm_read_byte(str++) );        // rs=1 f[^
  }
  LCDC_RS_LOW();            // LCD RS = 0  R}h
}


//
// Po
//
void lcdc_putch( char ch ) {
  switch( ch ) {
    case  LF:                   // \n = 0x0A J[\si̍sցj
      lcdc_xy( 0, lcdy+1 );
      break;
    default:
      LCDC_RS_HIGH();           // LCD RS = 1  f[^
      lcdc_write8( ch );        // rs=1 f[^
      LCDC_RS_LOW();            // LCD RS = 0  R}h
      
      lcdx++;
      if( lcdx >=LCDC_MAX_X ) {
        lcdc_xy( 0, lcdy+1 );
      }
      break;
  }
}


//
// o
//
void lcdc_putstr( char *str ) {
  while( *str ) {
    lcdc_putch( *str++ );
  }
}


//
// Flash̕񑗐M
//
void _lcdc_putstr_pgm( const prog_char *str ) {
  char c;
  while( (c=pgm_read_byte(str++)) != 0 ) {
    lcdc_putch( c );
  }
}


//
// PoCgkbcɑ
//
static void lcdc_write8( uint8 data ) {
#ifdef LCDC_DATA_HIGH
  lcdc_write4( data );          // ʂSrbgo
  lcdc_write4( data<<4 );       // ʂSrbgo
#else
  lcdc_write4( data>>4 );       // ʂSrbgo
  lcdc_write4( data );          // ʂSrbgo
#endif
  dly_usec( 80 );               // o͂ɂ鎞
}


//
// f[^Srbgkbcɑ
//
static void lcdc_write4( uint8 data ) {
  uint8 port;
  
  LCDC_E_HIGH();                 // LCD ENABLE = 1 
  port = LCDC_DATA;              // |[gɏo͂Ăf[^ǂށiAVRLj
#ifdef LCDC_DATA_HIGH
  LCDC_DATA = (data&0xF0)|(port&0x0F);  // ʂSrbg
#else
  LCDC_DATA = (data&0x0F)|(port&0xF0);  // ʂSrbg
#endif
//  dly_usec( 1 );                 // 
  LCDC_E_LOW();                  // LCD ENABLE = 0  pX=290ns  ZbgAbv=90ns
}


//
// obt@1kbcɑ
//
void lcdc_bufout( void ) {
  static uint8 pos=0;
  static uint8 line=0x30;
  uint8 outdata;
  
  if( line != (pos&0x30) ) {    // sςAhXo͂
    line = (pos&0x30);
    outdata = 0x80;
    if( LCDC_MAX_Y==2 ) {
      if( line==0x10 ) outdata = 0xC0;
    }else{
      if     ( line==0x10 ) outdata = 0xC0;
      else if( line==0x20 ) outdata = 0x90;
      else if( line==0x30 ) outdata = 0xD0;
    }
  }else{
    LCDC_RS_HIGH();             // LCD RS = 1  f[^
    outdata = lcdc_buf[pos++];  // obt@ꕶo
    if( outdata == 0) outdata = ' ';  // null Ȃ󔒂o
    if( LCDC_MAX_Y==2 ) {
      if( pos==0x20 ) pos = 0;
    }else{
      if( pos==0x40 ) pos = 0;
    }
  }
#ifdef LCDC_DATA_HIGH
  lcdc_write4( outdata );       // ʂSrbgo
  lcdc_write4( outdata<<4 );    // ʂSrbgo
#else
  lcdc_write4( outdata>>4 );    // ʂSrbgo
  lcdc_write4( outdata );       // ʂSrbgo
#endif
  LCDC_RS_LOW();                // LCD RS = 0  R}h
}


//
//      ԑ҂isecPʁj CPU_CLOCK=24576000
//
__attribute__((noinline)) void dly_usec( UH timeus ) {
    __asm__ __volatile__("\n"
      "1:\n\t"
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  nop\n\t"         //1
      "  sbiw %0,1\n\t"   //2
      "  brne 1b\n\t"     //2 1
      :
      :"w"(timeus)
    );
}

